SystemOrganization addCategory: #'Uqbar-MetaProgramming-Tools'!
SystemOrganization addCategory: #'Uqbar-Metaprogramming-Refactorings'!
SystemOrganization addCategory: #'Uqbar-Metaprogramming-Example'!

TestCase subclass: #AgeOfEmpiresTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'!

!AgeOfEmpiresTest methodsFor: 'tests' stamp: 'npasserini 4/24/2012 20:16'!
testSaveGame
	| original saved fileName |
	
	"Crear un juego y bajarlo a disco"
	original := self crearMapaEjemplo.
	fileName := 'game1.dat'
	
	original saveAs: fileName.
	
	"Recuperar el juego del disco y ver que obtengo los mismos datos"
	saved := Mapa loadFrom: fileName.
	self assert: fileName = saved.
	! !

TestCase subclass: #SimpleExtractTraitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Refactorings'!

!SimpleExtractTraitTest methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 5/10/2011 20:32'!
category
	^ self class category! !

!SimpleExtractTraitTest methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 5/9/2011 23:43'!
setUp
	| animal perro moveteCode |
	animal := Object
		subclass: #Animal
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
		
	perro := animal subclass: #Perro
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	
	moveteCode := 'movete
	Transcript show: ''Camino en mis cuatro patas'''.
	
	perro compile: moveteCode classified: 'Movilidad'.
	! !

!SimpleExtractTraitTest methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 5/10/2011 20:31'!
tearDown
	(Smalltalk at: #Perro) removeFromSystem.
	(Smalltalk at: #Animal) removeFromSystem. 
	(Smalltalk at: #TCuadrupedo) removeFromSystem. 
! !

!SimpleExtractTraitTest methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 5/10/2011 20:31'!
testExtractTrait 
	SimpleExtractTraitRefactoring 
		extractTrait: #TCuadrupedo
		withMethods: #(movete)
		fromClass: (Smalltalk at: #Perro)
		
	! !

Object subclass: #Factorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'!

!Factorial methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:59'!
factorial: x
	x = 8 ifTrue: [ ^40320 ].
	x = 7 ifTrue: [ ^5040 ].
	x = 6 ifTrue: [ ^720 ].
	x = 5 ifTrue: [ ^120 ].
	^ self factorialDe: x.
	! !

!Factorial methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:53'!
factorialDe: x
	| f method newSource |
	f := 1. 
	1 to: x do: [:i | f := f * i ].
	
	self class compile: (self newSourceInput: x factorial: f).

	^ f.! !

!Factorial methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:58'!
newSourceInput: x factorial: f
	| method source lines |
	method := self class methodDictionary at: #factorial:.	
	lines := method getSource lines.
	source := (String streamContents: [:s | lines allButFirst asStringOn: s delimiter:  '
' ]).

	^ 'factorial: x
	x = <1p> ifTrue: [ ^<2p> ].
<3s>' expandMacrosWith: x with: f with: source.
! !

Object subclass: #GenericComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-MetaProgramming-Tools'!

!GenericComparator methodsFor: 'as yet unclassified' stamp: 'npasserini 10/29/2011 17:22'!
compare: unObjeto with: otroObjeto
	^ unObjeto class = otroObjeto class and: [ unObjeto class instVarNames allSatisfy: [:varName |
		(unObjeto instVarNamed: varName) = (otroObjeto instVarNamed: varName)
	]]! !

!GenericComparator methodsFor: 'as yet unclassified' stamp: 'npasserini 10/29/2011 17:27'!
compareBySelector: unObjeto with: otroObjeto
	^ unObjeto class = otroObjeto class and: [ 
		(unObjeto class selectors select: #isUnary) allSatisfy: [:selector |
			(unObjeto perform: selector) = (otroObjeto perform: selector)]
	]! !

Object subclass: #Mapa
	instanceVariableNames: 'personajes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'!

!Mapa class methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
loadFrom: aFileName
	self flag: #todo! !

!Mapa methodsFor: 'accessing' stamp: 'npasserini 4/24/2012 20:16'!
personajes
	^ personajes! !

!Mapa methodsFor: 'accessing' stamp: 'npasserini 4/24/2012 20:16'!
personajes: anObject
	personajes := anObject! !

!Mapa methodsFor: 'editing keys' stamp: 'npasserini 4/24/2012 20:16'!
save: aFileName
	self flag: #todo! !

Object subclass: #SimpleExtractSuperclassRefactoring
	instanceVariableNames: 'target superClassName selectors instanceVariableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Refactorings'!

!SimpleExtractSuperclassRefactoring class methodsFor: 'as yet unclassified' stamp: 'npasserini 10/28/2011 16:01'!
extractSuperclass: newSuperClassName 
	withInstanceVariables: instanceVariableNames
	andMethods: selectors 
	fromClass: aClass 
	
	self new
		target: aClass;
		superClassName: newSuperClassName;
		instanceVariableNames: instanceVariableNames;
		selectors: selectors; 
		execute.
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'refactoring' stamp: 'npasserini 10/28/2011 16:26'!
createSuperclass.
	^ target superclass
		subclass:  self superClassName
		instanceVariableNames: self superclassInstanceVariablesDefinition
		classVariableNames:  ''
		poolDictionaries:  ''
		category: target category.
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'refactoring' stamp: 'npasserini 10/28/2011 16:25'!
execute
	| superclass |
	superclass := self createSuperclass.
	self selectors do: [:selector | self moveMethodNamed: selector to: superclass].
	self makeTargetSubclassOf: superclass.
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
instanceVariableNames
	^ instanceVariableNames! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
instanceVariableNames: anObject
	instanceVariableNames := anObject! !

!SimpleExtractSuperclassRefactoring methodsFor: 'instance-variables' stamp: 'npasserini 10/28/2011 16:17'!
instanceVariablesDefinitionFor: aCollection
	^ (String streamContents: [:s | aCollection asStringOn: s delimiter: ' ' ])

! !

!SimpleExtractSuperclassRefactoring methodsFor: 'refactoring' stamp: 'npasserini 10/28/2011 16:23'!
makeTargetSubclassOf: superclass.
	superclass
		subclass:  self target name
		instanceVariableNames: self targetInstanceVariablesDefinition
		classVariableNames:  ''
		poolDictionaries:  ''
		category: target category.
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'refactoring' stamp: 'npasserini 10/28/2011 16:22'!
moveMethodNamed: selector to: newClass
	| method |
	method := self target methodDictionary at: selector.
	self target removeSelector: selector.
	newClass compile: method getSource.
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
selectors
	^ selectors! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
selectors: anObject
	selectors := anObject! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
superClassName
	^ superClassName! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
superClassName: anObject
	superClassName := anObject! !

!SimpleExtractSuperclassRefactoring methodsFor: 'instance-variables' stamp: 'npasserini 10/28/2011 16:19'!
superclassInstanceVariablesDefinition
	^ self instanceVariablesDefinitionFor: self instanceVariableNames.
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
target
	^ target! !

!SimpleExtractSuperclassRefactoring methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 15:56'!
target: anObject
	target := anObject! !

!SimpleExtractSuperclassRefactoring methodsFor: 'instance-variables' stamp: 'npasserini 10/28/2011 16:28'!
targetInstanceVariables	
	^ self target instVarNames difference: self instanceVariableNames 
! !

!SimpleExtractSuperclassRefactoring methodsFor: 'instance-variables' stamp: 'npasserini 10/28/2011 16:27'!
targetInstanceVariablesDefinition
	^ self instanceVariablesDefinitionFor: self targetInstanceVariables	
! !

Object subclass: #SimpleExtractTraitRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Refactorings'!

!SimpleExtractTraitRefactoring class methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 5/10/2011 20:25'!
extractTrait: traitName withMethods: selectors fromClass: aClass 
	| trait |
	trait := Trait named: traitName
		uses: {}
		category: aClass category.
		
	selectors do: [:selector | | method |
		method := aClass methodDictionary at: selector.
		aClass removeSelector: selector.
		trait compile: method getSource.
	].
	
	aClass addToComposition: trait.
! !

Object subclass: #Soldado
	instanceVariableNames: 'posicion puntosDeVida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'!

!Soldado class methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
enPosicion: unaPosicion
	^ self new initialize: unaPosicion! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
atacar: unOponente
	(self estaCercaDe: unOponente) 
		whileFalse: [ self avanzarHacia: unOponente posicion ].
		
	self golpear: unOponente.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
avanzarHacia: unOponente
	posicion := posicion +  ((self direccionHacia: unOponente) * self paso)! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
direccionHacia: unOponente
	(self posicion - unOponente posicion) normalized.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
estaCercaDe: unOponente
	(self posicion dist: unOponente posicion) < 5! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
fuerza
	^ 10.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
golpear: aSoldado 
	aSoldado recibirDao: self fuerza.! !

!Soldado methodsFor: 'initialization' stamp: 'npasserini 4/24/2012 20:16'!
initialize: aPoint 
	posicion := aPoint.
	puntosDeVida := 100.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
paso
	^ (puntosDeVida / 10)! !

!Soldado methodsFor: 'accessing' stamp: 'npasserini 4/24/2012 20:16'!
posicion
	^ posicion.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'npasserini 4/24/2012 20:16'!
recibirDao: unaPotencia
	puntosDeVida := puntosDeVida - unaPotencia! !
